---
title: Using the CSS Typed Object Model
slug: Web/API/CSS_Typed_OM_API/Guide
tags:
  - CSS
  - CSS Typed OM
  - Houdini
  - Learn
---
<p>The <strong><a href="/en-US/docs/Web/Houdini/CSS_Typed_OM">CSS Typed Object Model API</a></strong> exposes CSS values as typed JavaScript objects to allow their performant manipulation.</p>

<p>Converting <a href="/en-US/docs/Web/API/CSS_Object_Model">CSS Object Model</a> value strings into meaningfully-typed JavaScript representations and back (via {{domxref('HTMLElement.style')}}) can incur a significant performance overhead.</p>

<p>The CSS Typed OM makes CSS manipulation more logical and performant by providing object features (rather than CSSOM string manipulation), providing access to types, methods, and an object model for CSS values.</p>

<p>This article provides an introduction to all of its main features.</p>

<h2 id="computedStyleMap">computedStyleMap()</h2>

<div id="example1">
<p>With the CSS Typed OM API, we can access all the CSS properties and values — including custom properties — that are impacting an element. Let's see how this works by creating our first example, which explores {{domxref('Element.computedStyleMap()', 'computedStyleMap()')}}.</p>

<p>We start with some HTML: a paragraph with a link, as well as a definition list to which we will add all the CSS Property / Value pairs.</p>

<pre class="brush: html notranslate">&lt;p&gt;
   &lt;a href="https://example.com"&gt;Link&lt;/a&gt;
&lt;/p&gt;
&lt;dl id="regurgitation"&gt;&lt;/dl&gt;</pre>

<p>We add JavaScript to grab our unstyled link and return back a definition list of all the default CSS property values impacting the link using <code>computedStyleMap()</code>.</p>

<pre class="brush: js notranslate">// get the element
const myElement = document.querySelector('a');

// get the &lt;dl&gt; we'll be populating
const stylesList = document.querySelector('#regurgitation');

// Retrieve all computed styles with computedStyleMap()
const defaultComputedStyles = myElement.computedStyleMap();

// iterate thru the map of all the properties and values, adding a &lt;dt&gt; and &lt;dd&gt; for each
for (const [prop, val] of defaultComputedStyles) {
	// properties
	const cssProperty = document.createElement('dt');
	cssProperty.appendChild(document.createTextNode(prop));
	stylesList.appendChild(cssProperty);

	// values
	const cssValue = document.createElement('dd');
	cssValue.appendChild(document.createTextNode(val));
	stylesList.appendChild(cssValue);
}</pre>

<p>The <code>computedStyleMap()</code> method returns a {{domxref('StylePropertyMapReadOnly')}} object containing the <code><a href="/en-US/docs/Web/API/StylePropertyMapReadOnly/size">size</a></code> property, which indicates how many properties are in the map. We iterate through the style map, creating a  <code><a href="/en-US/docs/Web/HTML/Element/dt">&lt;dt&gt;</a></code> and <code><a href="/en-US/docs/Web/HTML/Element/dd">&lt;dd&gt;</a></code> for each property and value respectively.</p>

<p>In  <a href="/en-US/docs/Web/API/Element/computedStyleMap#Browser_compatibility">browsers that support <code>computedStyleMap()</code></a>, you'll see a list of all the CSS properties and values. In other browsers, you'll just see a link.</p>

<p>{{EmbedLiveSample("example1", 120, 300)}}</p>

<p>Did you realize how many default CSS properties a link had? Update the JavaScript on line 2 to select the {{htmlelement("p")}} rather than the {{htmlelement("a")}}. You'll notice a difference in the <code><a href="/en-US/docs/Web/CSS/margin-top">margin-top</a></code> and <code><a href="/en-US/docs/Web/CSS/margin-bottom">margin-bottom</a></code> default computed values.</p>
</div>

<h3 id=".get_method_custom_properties">.get() method / custom properties</h3>

<p>Let's update our example to only retrieve a few properties and values. Let's start by adding some CSS to our example, including a custom property and an inhertable property:</p>

<div id="example2">
<pre class="brush: css notranslate">p {
  font-weight: bold;
}

a {
  --color: red;
  color: var(--color);
}</pre>

<p>Instead of getting <em>all</em> the properties, we create an array of properties of interest and use the {{domxref('StylePropertyMapReadOnly.get()')}} method to get each of their values:</p>

<div class="hidden">
<pre class="brush: html notranslate">&lt;p&gt;
   &lt;a href="https://example.com"&gt;Link&lt;/a&gt;
&lt;/p&gt;
&lt;dl id="regurgitation"&gt;&lt;/dl&gt;</pre>
</div>

<pre class="brush: js notranslate">// get the element
const myElement = document.querySelector('a');

// get the &lt;dl&gt; we'll be populating
const stylesList = document.querySelector('#regurgitation');

// Retrieve all computed styles with computedStyleMap()
const allComputedStyles = myElement.computedStyleMap();

// array of properties we're interested in
const ofInterest = ['font-weight', 'border-left-color', 'color', '--color'];

// iterate through our properties of interest
for ( let i = 0; i &lt; ofInterest.length; i++ ) {
  	// properties
  const cssProperty = document.createElement('dt');
  cssProperty.appendChild(document.createTextNode(ofInterest[i]));
  stylesList.appendChild(cssProperty);
  	// values
  const cssValue = document.createElement('dd');
  cssValue.appendChild(document.createTextNode( allComputedStyles.get(ofInterest[i])));
	stylesList.appendChild(cssValue);
}
</pre>

<p>{{EmbedLiveSample("example2", 120, 300)}}</p>
</div>

<p>We included {{cssxref('border-left-color')}} to demonstrate that, had we included all the properties, every value that defaults to <code><a href="/en-US/docs/Web/CSS/color_value">currentcolor</a></code> (including {{cssxref('caret-color')}}, {{cssxref('outline-color')}}, {{cssxref('text-decoration-color')}}, {{cssxref('column-rule-color')}}, etc.) would return <code>rgb(255, 0, 0)</code>. The link has inherited <code>font-weight: bold;</code> from the paragraph's styles, listing it as <code>font-weight: 700</code>.  Custom properties, like our <code>--color: red</code> , are properties. As such, they are accessible via <code>get()</code>.</p>

<p>You'll note that custom properties retain the value as written in the stylesheet, whereas computed styles will be listed as the computed value — {{cssxref('color')}} was listed as an <a href="/en-US/docs/Web/CSS/color_value"><code>rgb()</code> </a>value and the {{cssxref('font-weight')}} returned was <code>700</code> even though we use a {{cssxref('&lt;color&gt;', 'named color')}} and the <code>bold</code> keyword.</p>

<h3 id="CSSUnitValue_and_CSSKeywordValue">CSSUnitValue and CSSKeywordValue</h3>

<p>The power of the CSS Typed OM is that values are separate from units; parsing and concatenating string values may become be a thing of the past. Every CSS property in a style map has a value. If the value is a keyword, the object returned is a <code><a href="/en-US/docs/Web/API/CSSKeywordValue">CSSKeywordValue</a></code>. If the value is numeric, a <code><a href="/en-US/docs/Web/API/CSSUnitValue">CSSUnitValue</a></code> is returned.</p>

<p><code>CSSKeywordValue</code> is a class that defines keywords like <code>inherit</code>, <code>initial</code>, <code>unset</code>, and other strings you don't quote, such as <code>auto</code> and <code>grid</code>. This subclass gives you a <code>value</code> property via {{domxref("cssKeywordValue.value")}}.</p>

<p><code>CSSUnitValue</code> is returned if the value is a unit type. It is a class that defines numbers with units of measurement like <code>20px</code>, <code>40%</code>, <code>200ms</code>, or <code>7</code>. It is returned with two properties: a <code>value</code> and a <code>unit</code>. With this type we can access the numeric value — {{domxref('cssUnitValue.value')}} — and its unit — {{domxref('cssUnitValue.unit')}}.</p>

<p>Let's write a plain paragraph, apply no styles, and inspect a few of its CSS properties by returning a table with the unit and value:</p>

<pre class="brush: html notranslate">&lt;p&gt;
   This is a paragraph with some content. Open up this example in Codepen or
   JSFiddle, and change some features. Try adding some CSS, such as a width
   for this paragraph, or adding a CSS property to the ofInterst array.
&lt;/p&gt;
&lt;table id="regurgitation"&gt;
  &lt;thead&gt;
    &lt;tr&gt;
      &lt;th&gt;Property&lt;/th&gt;
      &lt;th&gt;Value&lt;/th&gt;
      &lt;th&gt;Unit&lt;/th&gt;
    &lt;/tr&gt;
&lt;/table&gt;</pre>

<p>For each property of interest, we list the name of the property, use <code>.get(propertyName).value</code> to return the value, and, if the object returned by the <code>get()</code> is a <code>CSSUnitValue</code>, list the unit type we retrieve with <code>.get(propertyName).unit</code>.</p>

<pre class="brush: js notranslate">// get the element we're inspecting
const myElement = document.querySelector('p');

// get the table we'll be populating
const stylesTable = document.querySelector('#regurgitation');

// Retrieve all computed styles with computedStyleMap()
const allComputedStyles = myElement.computedStyleMap();

// array of properties we're interested in
const ofInterest = ['padding-top', 'margin-bottom', 'font-size', 'font-stretch',
     'animation-duration', 'animation-iteration-count', 'width', 'height'];
// iterate thru our properties of interest
for ( let i = 0; i &lt; ofInterest.length; i++ ) {
      // create a row
    const row = document.createElement( 'tr' );

      // add the name of the property
    const cssProperty = document.createElement( 'td' );
    cssProperty.appendChild( document.createTextNode( ofInterest[i] ) );
    row.appendChild( cssProperty );

      // and the unitless value
    const cssValue = document.createElement( 'td' );
      // shrink long floats to 1 decimal point
    let propVal = allComputedStyles.get( ofInterest[i] ).value;
    propVal = ( propVal % 1 ) ? propVal.toFixed( 1 ) : propVal;
    cssValue.appendChild(document.createTextNode( propVal ));
    row.appendChild( cssValue );

      // and the type of unit
    const cssUnit = document.createElement( 'td' );
    cssUnit.appendChild( document.createTextNode( allComputedStyles.get( ofInterest[i] ).unit ));
    row.appendChild( cssUnit );

    //add the row to the table
    stylesTable.appendChild( row );
}</pre>

<p>{{EmbedLiveSample("CSSUnitValue_and_CSSKeywordValue", 120, 300)}}</p>

<p>For those of you using a non-supporting browser, the above output should looks something like this:</p>

<table id="regurgitation" style="height: 424px; width: 1336px;">
 <thead>
  <tr>
   <th>Property</th>
   <th>Value</th>
   <th>Unit</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>padding-top</td>
   <td>0</td>
   <td>px</td>
  </tr>
  <tr>
   <td>margin-bottom</td>
   <td>16</td>
   <td>px</td>
  </tr>
  <tr>
   <td>font-size</td>
   <td>16</td>
   <td>px</td>
  </tr>
  <tr>
   <td>font-stretch</td>
   <td>100</td>
   <td>percent</td>
  </tr>
  <tr>
   <td>animation-duration</td>
   <td>0</td>
   <td>s</td>
  </tr>
  <tr>
   <td>animation-iteration-count</td>
   <td>1</td>
   <td>number</td>
  </tr>
  <tr>
   <td>width</td>
   <td>auto</td>
   <td>undefined</td>
  </tr>
  <tr>
   <td>height</td>
   <td>auto</td>
   <td>undefined</td>
  </tr>
 </tbody>
</table>

<p>You'll note the {{cssxref('&lt;length&gt;')}} unit returned is <code>px</code>, the {{cssxref('&lt;percentage&gt;')}} unit returned is <code>percent</code>, the {{cssxref('&lt;time&gt;')}} unit is <code>s</code> for 'seconds', and the unitless {{cssxref('&lt;number&gt;')}} unit is <code>number</code>.</p>

<p>We didn't declare a {{cssxref('width')}} or a {{cssxref('height')}} for the paragraph, both of which default to <code>auto</code> and therefore return a <code><a href="/en-US/docs/Web/API/CSSKeywordValue">CSSKeywordValue</a></code> instead of a <code><a href="/en-US/docs/Web/API/CSSUnitValue">CSSUnitValue</a></code>. <code>CSSKeywordValue</code>s do not have a unit property, so in these cases our <code>get().unit</code> returns <code>undefined</code>. </p>

<p>Had the <code>width</code> or <code>height</code> been defined in a <code>&lt;length&gt;</code> or <code>&lt;percent&gt;</code>, the <code><a href="/en-US/docs/Web/API/CSSUnitValue">CSSUnitValue</a></code> unit would have been <code>px</code> or <code>percent</code> respectively.</p>

<p>There are other types available:</p>

<ul>
 <li>An <code><a href="/en-US/docs/Web/CSS/image">&lt;image&gt;</a></code> will return a {{domxref('CSSImageValue')}}.</li>
 <li>A <code><a href="/en-US/docs/Web/CSS/color_value">&lt;color&gt;</a></code> would return a {{domxref('CSSStyleValue')}}.</li>
 <li>A {{cssxref('transform')}} returns a <code>CSSTransformValue</code>.</li>
 <li>A <a href="/en-US/docs/Web/CSS/--*">custom property</a> returns a {{domxref('CSSUnparsedValue')}}.</li>
</ul>

<p>You can use a <code>CSSUnitValue</code> or <code>CSSKeywordValue</code> to create other objects. For example, the parameters for a {{domxref('CSSPositionValue')}} is one to two <code>CSSUnitValues</code> or <code>CSSKeywordValues</code>, or one of each:</p>

<pre class="brush: js notranslate">let position = new CSSPositionValue(
    new CSSKeywordValue("center"),
    new CSSUnitValue(10, "px"));</pre>

<h2 id="CSSStyleValue">CSSStyleValue</h2>

<p>The <code>CSSStyleValue</code> interface of the the <a href="/en-US/docs/Web/API/CSS_Typed_Object_Model_API">CSS Typed Object Model API</a> is the base class of all CSS values accessible through the Typed OM API, including {{domxref('CSSImageValue')}}, {{domxref('CSSKeywordValue')}}, {{domxref('CSSNumericValue')}}, {{domxref('CSSPositionValue')}}, {{domxref('CSSTransformValue')}}, and {{domxref('CSSUnparsedValue')}}.</p>

<p>It has two methods:</p>

<ul>
 <li>{{domxref("CSSStyleValue.parse()")}}</li>
 <li>{{domxref("CSSStyleValue.parseAll()")}} </li>
</ul>

<p>As noted above, <code>StylePropertyMapReadOnly.get('--customProperty')</code> returns a {{domxref('CSSUnparsedValue')}}. We can parse <code>CSSUnparsedValue</code> object instances with the inherited {{domxref('CSSStyleValue.parse()')}} and {{domxref('CSSStyleValue.parseAll()')}} methods.</p>

<p>Let's examine a CSS example with several custom properties, transforms, <code>calc()</code>s, and other features. We'll take a look at that their types are by employing short JavaScript snippets outputting to {{domxref('console.log()')}}:</p>

<div id="example3">
<pre class="brush: css notranslate">:root {
    --mainColor: hsl(198, 43%, 42%);
    --black: hsl(0, 0%, 16%);
    --white: hsl(0,0%,97%);
    --unit: 1.2rem;
}

button {
	--mainColor: hsl(198, 100%, 66%);
	display: inline-block;
	padding: var(--unit) calc(var(--unit)*2);
	width: calc(30% + 20px);
	background: no-repeat 5% center url(https://mdn.mozillademos.org/files/16793/magicwand.png) var(--mainColor);
	border: 4px solid var(--mainColor);
	border-radius: 2px;
	font-size: calc(var(--unit)*2); color: var(--white);
	cursor: pointer;
	transform: scale(0.95);
}
</pre>

<p>Let's add the class to a button (a button which does nothing).</p>

<pre class="brush: html notranslate">&lt;button&gt;Styled Button&lt;/button&gt;
</pre>

<pre class="brush: js; hidden notranslate">// get the element
const button = document.querySelector( 'button' );

// Retrieve all computed styles with computedStyleMap()
const allComputedStyles = button.computedStyleMap();

// CSSMathSum Example
let btnWidth = allComputedStyles.get('width')

console.log( btnWidth ); // CSSMathSum
console.log( btnWidth.values ); // CSSNumericArray {0: CSSUnitValue, 1: CSSUnitValue, length: 2}
console.log( btnWidth.operator ); // 'sum'

// CSSTransformValue
let transform = allComputedStyles.get('transform');

console.log( transform );        // CSSTransformValue {0: CSSScale, 1: CSSTranslate, length: 2, is2D: true}
console.log( transform.length ); // 1
console.log( transform[0] );     // CSSScale {x: CSSUnitValue, y: CSSUnitValue, z: CSSUnitValue, is2D: true}
console.log( transform[0].x );   // CSSUnitValue {value: 0.95, unit: "number"}
console.log( transform[0].y );   // CSSUnitValue {value: 0.95, unit: "number"}
console.log( transform[0].z );   // CSSUnitValue {value: 1, unit: "number"}
console.log( transform.is2D );   // true

// CSSImageValue
let bgImage = allComputedStyles.get('background-image');

console.log( bgImage );             // CSSImageValue
console.log( bgImage.toString() ); // url("https://mdn.mozillademos.org/files/16793/magicwand.png")

// CSSUnparsedValue
let unit = allComputedStyles.get('--unit');

console.log( unit ) //

let parsedUnit = CSSNumericValue.parse( unit );
console.log( parsedUnit );
console.log( parsedUnit.unit );
console.log( parsedUnit.value );
</pre>
</div>

<p class="hidden">For this example to work, the example must be closed out here.</p>

<p>{{EmbedLiveSample("example3", 120, 300)}}</p>

<p>We've created a blue button with a magic wand background image.</p>

<p>We grab our <code>StylePropertyMapReadOnly</code> with the following JavaScript:</p>

<pre class="brush: js notranslate">const allComputedStyles = document.querySelector('button').computedStyleMap();</pre>

<p>The following examples reference <code>allComputedStyles</code>:</p>

<h3 id="CSSUnparsedValue">CSSUnparsedValue</h3>

<p>The {{domxref('CSSUnparsedValue')}} represents <a href="/en-US/docs/Web/CSS/Using_CSS_custom_properties">custom properties</a>:</p>

<pre class="brush: js notranslate">// CSSUnparsedValue
let unit = allComputedStyles.get('--unit');

console.log( unit )    // CSSUnparsedValue {0: " 1.2rem", length: 1}
console.log (unit[0] ) // " 1.2rem" </pre>

<p>When we invoke <code>get()</code>, a custom property of type <code>CSSUnparsedValue</code> is returned. Note the space before the <code> 1.2rem</code>.  To get a unit and value, we need a <code>CSSUnitValue</code>, which we can retrieve using the <code>CSSStyleValue.parse()</code> method on the <code>CSSUnparsedValue</code>.</p>

<pre class="brush: js notranslate">let parsedUnit = CSSNumericValue.parse( unit );
console.log( parsedUnit );        // CSSUnitValue {value: 1.2, unit: "rem"}
console.log( parsedUnit.unit );   // "rem"
console.log( parsedUnit.value );  // 1.2</pre>

<h3 id="CSSMathSum">CSSMathSum</h3>

<p>Although the <code><a href="/en-US/docs/Web/HTML/Element/button">&lt;button&gt;</a></code> element is an inline element by default, we've added <code><a href="/en-US/docs/Web/CSS/CSS_Display">display: inline-block;</a></code> to enable sizing. In our CSS we have <code>width: calc(30% + 20px);</code>, which is a <code><a href="/en-US/docs/Web/CSS/calc">calc()</a></code> function to define the width.</p>

<p>When we <code>get()</code> the <code>width</code>, we get a <code><a href="/en-US/docs/Web/API/CSSMathSum">CSSMathSum</a></code> returned. {{domxref('CSSMathSum.values')}} is a {{domxref('CSSNumericArray')}} with 2 <code>CSSUnitValues</code>.</p>

<p>The value of {{domxref('CSSMathValue.operator')}} is <code>sum</code>:</p>

<pre class="brush: js notranslate">let btnWidth = allComputedStyles.get('width')

console.log( btnWidth );             // CSSMathSum
console.log( btnWidth.values );      // CSSNumericArray {0: CSSUnitValue, 1: CSSUnitValue, length: 2}
console.log( btnWidth.operator );    // 'sum'</pre>

<h3 id="CSSTransformValue_with_CSSScale">CSSTransformValue with CSSScale</h3>

<p>The <code><a href="/en-US/docs/Web/CSS/CSS_Display">display: inline-block;</a></code> also enables transforming. In our CSS we have <code>transform: scale(0.95);</code>, which is a {{cssxref('transform')}} function. </p>

<pre class="brush: js notranslate">let transform = allComputedStyles.get('transform');

console.log( transform );        // CSSTransformValue {0: CSSScale, 1: CSSTranslate, length: 2, is2D: true}
console.log( transform.length ); // 1
console.log( transform[0] );     // CSSScale {x: CSSUnitValue, y: CSSUnitValue, z: CSSUnitValue, is2D: true}
console.log( transform[0].x );   // CSSUnitValue {value: 0.95, unit: "number"}
console.log( transform[0].y );      // CSSUnitValue {value: 0.95, unit: "number"}
console.log( transform[0].z );   // CSSUnitValue {value: 1, unit: "number"}
console.log( transform.is2D );   // true</pre>

<p>When we <code>get()</code> the <code>transform</code> property, we get a {{domxref('CSSTransformValue')}}. We can query the length (or number) of transform functions with the .<code>length</code> property.</p>

<p>Seen as we have a length of <code>1</code>, which represents a single transform function, we log the first object and get a <code>CSSScale</code> object. We get <code>CSSUnitValues</code> when we query the <code>x</code>, <code>y</code>, and <code>z</code> scaling. The readonly <code>CSSScale.is2D</code> property is <code>true</code> in this scenario.</p>

<p>Had we added <code>translate()</code>, <code>skew()</code>, and <code>rotate()</code> transform functions, the length would have been <code>4</code>, each with their own <code>x</code>, <code>y</code>, <code>z</code> values, and each with an <code>.is2D</code> property. For example, had we included <code>transform: translate3d(1px, 1px, 3px)</code>, the <code>.get('transform')</code> would have returned a <code>CSSTranslate</code> with <code>CSSUnitValues</code> for <code>x</code>, <code>y</code>, and <code>z</code>, and the readonly .i<code>s2D</code> property would have been <code>false</code>.</p>

<h3 id="CSSImageValue">CSSImageValue</h3>

<p>Our button has one background image: a magic wand.</p>

<pre class="brush: js notranslate">let bgImage = allComputedStyles.get('background-image');

console.log( bgImage );             // CSSImageValue
console.log( bgImage.toString() );  // url("https://mdn.mozillademos.org/files/16793/magicwand.png")</pre>

<p>When we <code>get()</code> the <code>'background-image'</code>, a {{domxref('CSSImageValue')}} is returned. While we used the CSS {{cssxref('background')}} shorthand property, the inherited {{domxref('Object.prototype.toString()')}} method, shows we returned only the image, '<code>url("https://mdn.mozillademos.org/files/16793/magicwand.png")'</code>.</p>

<p>Notice that the value returned is the absolute path to the image — this is returned even if the original <code>url()</code> value was relative. Had the background image been a gradient or multiple background images,  <code>.get('background-image') </code>would have returned a <code>CSSStyleValue</code>. The <code>CSSImageValue</code> is returned only if there is a single image, and only if that single image declaration is a URL.</p>

<h3 id="Summary">Summary</h3>

<p>This should get you started with understanding the CSS Typed OM. Take a look at all the <a href="/en-US/docs/Web/Houdini/learn/CSS_Typed_OM">CSS Typed OM</a> interfaces to learn more.</p>

<h2 id="See_Also">See Also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/CSS_Painting_API/Guide">Using the CSS Painting API</a></li>
</ul>
